| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | Protected Member Functions | Private Attributes | List of all members
InputCopyStream Class Reference

Extension of OutputStream to copy the content of the main input file. More...

`#include <src/PersistencySvc/InputCopyStream.h>`

Inheritance diagram for InputCopyStream:
[legend]
Collaboration diagram for InputCopyStream:
[legend]

## Public Member Functions
| InputCopyStream (const std::string &name, ISvcLocator *pSvcLocator)
| Standard algorithm Constructor. More...
StatusCode | initialize () override
| Initialize the instance. More...
StatusCode | finalize () override
| Finalize the instance. More...
StatusCode | collectObjects () override
| Collect all objects to be written to the output stream. More...
Public Member Functions inherited from OutputStream
StatusCode | initialize () override
| Initialize OutputStream. More...
StatusCode | finalize () override
| Terminate OutputStream. More...
StatusCode | execute () override
| Working entry point. More...
virtual StatusCode | connectConversionSvc ()
virtual bool | collect (IRegistry *dir, int level)
| Store agent's classback. More...
void | clearSelection ()
| Clear list of selected objects. More...
Public Member Functions inherited from Gaudi::details::LegacyAlgorithmAdapter
| LegacyAlgorithmAdapter (const std::string &name, ISvcLocator *svcloc, const std::string &version=PACKAGE_VERSION)
const EventContext & | getContext () const
bool | isExecuted () const
| Has this algorithm been executed since the last reset? More...
void | setExecuted (bool state) const
| Set the executed flag to the specified state. More...
void | resetExecuted ()
| Reset the executed state of the Algorithm for the duration of the current event. More...
bool | filterPassed () const
| Did this algorithm pass or fail its filter criterion for the last event? More...
void | setFilterPassed (bool state) const
| Set the filter passed flag to the specified state. More...
Public Member Functions inherited from Gaudi::Algorithm
| Algorithm (const std::string &name, ISvcLocator *svcloc, const std::string &version=PACKAGE_VERSION)
| Constructor. More...
StatusCode | sysStart () override
| Reinitialization method invoked by the framework. More...
StatusCode | sysInitialize () override
| Initialization method invoked by the framework. More...
StatusCode | sysReinitialize () override
| Reinitialization method invoked by the framework. More...
StatusCode | sysRestart () override
| Restart method invoked by the framework. More...
StatusCode | sysExecute (const EventContext &ctx) override
| The actions to be performed by the algorithm on an event. More...
StatusCode | sysStop () override
| System stop. More...
StatusCode | sysFinalize () override
| System finalization. More...
StatusCode | sysBeginRun () override
| beginRun method invoked by the framework. More...
StatusCode | sysEndRun () override
| endRun method invoked by the framework. More...
const std::string & | name () const override
| The identifying name of the algorithm object. More...
const Gaudi::StringKey & | nameKey () const override
const std::string & | type () const override
| The type of the algorithm object. More...
void | setType (const std::string &type) override
const std::string & | version () const override
unsigned int | index () const override
StatusCode | configure () override
| Dummy implementation of IStateful::configure() method. More...
StatusCode | terminate () override
| Dummy implementation of IStateful::terminate() method. More...
StatusCode | initialize () override
| the default (empty) implementation of IStateful::initialize() method More...
StatusCode | start () override
| the default (empty) implementation of IStateful::start() method More...
StatusCode | stop () override
| the default (empty) implementation of IStateful::stop() method More...
StatusCode | finalize () override
| the default (empty) implementation of IStateful::finalize() method More...
StatusCode | reinitialize () override
| the default (empty) implementation of IStateful::reinitialize() method More...
StatusCode | restart () override
| the default (empty) implementation of IStateful::restart() method More...
Gaudi::StateMachine::State | FSMState () const override
| returns the current state of the algorithm More...
Gaudi::StateMachine::State | targetFSMState () const override
| returns the state the algorithm will be in after the ongoing transition More...
StatusCode | beginRun () override
| Algorithm begin run. More...
StatusCode | endRun () override
| Algorithm end run. This method is called at the end of the event loop. More...
bool | isEnabled () const override
| Is this algorithm enabled or disabled? More...
bool | isSequence () const override
| Are we a Sequence? More...
unsigned int | errorCount () const
| Get the number of failures of the algorithm. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
SmartIF< IService > | service (const std::string &name, const bool createIf=true, const bool quiet=false) const
| Return a pointer to the service identified by name (or "type/name") More...
template<class T >
SmartIF< T > | service (const std::string &name, bool createIf=true, bool quiet=false) const
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
SmartIF< IChronoStatSvc > & | chronoSvc () const
| The standard Chrono & Stat service, Return a pointer to the service if present. More...
SmartIF< IChronoStatSvc > & | chronoStatService () const
SmartIF< IDataProviderSvc > & | detSvc () const
| The standard detector data service. More...
SmartIF< IDataProviderSvc > & | detDataService () const
SmartIF< IConversionSvc > & | detCnvSvc () const
| The standard detector data persistency conversion service. More...
SmartIF< IConversionSvc > & | detDataCnvService () const
SmartIF< IDataProviderSvc > & | eventSvc () const
| The standard event data service. More...
SmartIF< IDataProviderSvc > & | evtSvc () const
| shortcut for method eventSvc More...
SmartIF< IDataProviderSvc > & | eventDataService () const
SmartIF< IConversionSvc > & | eventCnvSvc () const
| The standard event data persistency conversion service. More...
SmartIF< IConversionSvc > & | eventDataCnvService () const
SmartIF< IHistogramSvc > & | histoSvc () const
| The standard histogram service. More...
SmartIF< IHistogramSvc > & | histogramDataService () const
SmartIF< INTupleSvc > & | ntupleSvc () const
| The standard N tuple service. More...
SmartIF< INTupleSvc > & | ntupleService () const
SmartIF< IRndmGenSvc > & | randSvc () const
| The standard RandomGen service, Return a pointer to the service if present. More...
SmartIF< IToolSvc > & | toolSvc () const
| The standard ToolSvc service, Return a pointer to the service if present. More...
SmartIF< IExceptionSvc > & | exceptionSvc () const
| Get the exception Service. More...
SmartIF< IAlgContextSvc > & | contextSvc () const
| get Algorithm Context Service More...
SmartIF< ITimelineSvc > & | timelineSvc () const
SmartIF< ISvcLocator > & | serviceLocator () const override
| The standard service locator. More...
SmartIF< ISvcLocator > & | svcLoc () const
| shortcut for method serviceLocator More...
SmartIF< IHiveWhiteBoard > & | whiteboard () const
SmartIF< IAlgExecStateSvc > & | algExecStateSvc () const
bool | registerContext () const
| register for Algorithm Context Service? More...
StatusCode | setProperties ()
| Set the algorithm's properties. More...
template<class T >
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, ToolHandle< T > &hndl, const std::string &doc="none")
template<class T >
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, ToolHandleArray< T > &hndlArr, const std::string &doc="none")
SmartIF< IMonitorSvc > & | monitorSvc () const
| Access the monitor service. More...
template<class T >
void | declareInfo (const std::string &name, const T &var, const std::string &desc) const
| Declare monitoring information. More...
void | declareInfo (const std::string &name, const std::string &format, const void *var, int size, const std::string &desc) const
| Declare monitoring information (special case) More...
void | acceptDHVisitor (IDataHandleVisitor *) const override
void | registerTool (IAlgTool *tool) const
void | deregisterTool (IAlgTool *tool) const
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, bool createIf=true)
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName, bool createIf=true)
template<class T >
void | addToolsArray (ToolHandleArray< T > &hndlArr)
const std::vector< IAlgTool * > & | tools () const
bool | isIOBound () const
void | setIOBound (bool value)
unsigned int | cardinality () const override
| Return the cardinality. More...
const std::vector< std::string > & | neededResources () const override
AlgExecState & | execState (const EventContext &ctx) const override
| reference to AlgExecState of Alg More...
std::ostream & | toControlFlowExpression (std::ostream &os) const override
| Produce string represention of the control flow expression. More...
Public Member Functions inherited from DataHandleHolderBase< CounterHolder< PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > > > >
std::vector< Gaudi::DataHandle * > | inputHandles () const override
std::vector< Gaudi::DataHandle * > | outputHandles () const override
virtual const DataObjIDColl & | extraInputDeps () const override
virtual const DataObjIDColl & | extraOutputDeps () const override
void | declare (Gaudi::DataHandle &handle) override
void | renounce (Gaudi::DataHandle &handle) override
const DataObjIDColl & | inputDataObjs () const override
const DataObjIDColl & | outputDataObjs () const override
void | addDependency (const DataObjID &id, const Gaudi::DataHandle::Mode &mode) override
Public Member Functions inherited from extends< CounterHolder< PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > > >, IDataHandleHolder >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
Public Member Functions inherited from CounterHolder< PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > > >
void | declareCounter (const std::string &tag, Gaudi::Accumulators::PrintableCounter &r)
const Gaudi::Accumulators::PrintableCounter * | findCounter (const std::string &tag) const
void | forEachCounter (Callable &&f) const
int | nCounters () const
std::size_t | nOfCountersToBePrinted ()
void | clearCounters ()
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > >
| PropertyHolder ()=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Public Member Functions inherited from CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > >
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const
| Backward compatibility function for getting the output level. More...
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...

## Protected Member Functions
bool | hasInput () const override
| Overridden from the base class (InputCopyStream has always input). More...
Protected Member Functions inherited from OutputStream
Gaudi::Algorithm * | decodeAlgorithm (const std::string &theName)
| Decode a single algorithm name. More...
void | decodeAlgorithms (Gaudi::Property< std::vector< std::string >> &theNames, std::vector< Gaudi::Algorithm * > &theAlgs)
| Decode specified list of Algorithms. More...
bool | isEventAccepted () const
| Test whether this event should be output. More...
DataStoreItem * | findItem (const std::string &path)
| Find single item identified by its path (exact match) More...
virtual StatusCode | writeObjects ()
| Select the different objects and write them to file. More...
Protected Member Functions inherited from Gaudi::details::LegacyAlgorithmAdapter
bool | isReEntrant () const override
Protected Member Functions inherited from Gaudi::Algorithm
std::vector< IAlgTool * > & | tools ()
bool | isInitialized () const override
| Has the Algorithm already been initialized? More...
bool | isFinalized () const override
| Has the Algorithm already been finalized? More...
void | setIndex (const unsigned int &idx) override
| set instantiation index of Alg More...
bool | isReEntrant () const override
Protected Member Functions inherited from DataHandleHolderBase< CounterHolder< PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > > > >
void | initDataHandleHolder ()
| initializes all handles - called by the sysInitialize method of any descendant of this More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > >
MSG::Level | setUpMessaging () const
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...

## Private Attributes
IDataStoreLeaves * | m_leavesTool = nullptr
| Pointer to the (public) tool used to retrieve the objects in a file. More...
Gaudi::Property< std::vector< std::string > > | m_tesVetoList {this, "TESVetoList", {}, "names of TES locations to Veto"}

## Additional Inherited Members
Public Types inherited from OutputStream
typedef std::vector< DataStoreItem * > | Items
typedef std::vector< std::string > | ItemNames
typedef std::map< Gaudi::Algorithm *, Items > | AlgDependentItems
typedef std::map< std::string, ItemNames > | AlgDependentItemNames
Public Types inherited from Gaudi::Algorithm
typedef Gaudi::PluginService::Factory< IAlgorithm *(const std::string &, ISvcLocator *)> | Factory
Public Types inherited from extends< CounterHolder< PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > > >, IDataHandleHolder >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Public Attributes inherited from Gaudi::Algorithm
friend | AlgorithmManager
Protected Attributes inherited from OutputStream
Gaudi::Property< ItemNames > | m_itemNames {this, "ItemList", {}, "vector of item names to be saved to this stream"}
Gaudi::Property< ItemNames > | m_optItemNames
Gaudi::Property< AlgDependentItemNames > | m_algDependentItemList
Gaudi::Property< bool > | m_doPreLoad
Gaudi::Property< bool > | m_doPreLoadOpt
Gaudi::Property< std::string > | m_output {this, "Output", {}, "name of the output file specification"}
Gaudi::Property< std::string > | m_outputName {this, "OutputFile", {}, "name of the output file"}
Gaudi::Property< std::string > | m_storeName
Gaudi::Property< std::string > | m_persName
Gaudi::Property< std::vector< std::string > > | m_acceptNames
Gaudi::Property< std::vector< std::string > > | m_requireNames
Gaudi::Property< std::vector< std::string > > | m_vetoNames
Gaudi::Property< bool > | m_verifyItems
bool | m_fireIncidents = true
| should I fire incidents for writing opening/closing etc? in the baseclass, always fire the incidents by default in e.g. More...
SmartIF< IIncidentSvc > | m_incidentSvc
| Reference to the incident service. More...
std::string | m_outputType = "UPDATE"
| Output type: NEW(NEW,CREATE,WRITE,RECREATE), UPDATE) More...
SmartIF< IDataProviderSvc > | m_pDataProvider
| Keep reference to the data provider service. More...
SmartIF< IDataManagerSvc > | m_pDataManager
| Keep reference to the data manager service. More...
SmartIF< IConversionSvc > | m_pConversionSvc
| Keep reference to the data conversion service. More...
DataStoreItem * | m_currentItem
| Keep track of the current item. More...
Items | m_itemList
| Vector of items to be saved to this stream. More...
Items | m_optItemList
| Vector of optional items to be saved to this stream. More...
AlgDependentItems | m_algDependentItems
| Items to be saved for specific algorithms. More...
IDataSelector | m_objects
| Collection of objects being selected. More...
int | m_events
| Number of events written to this output stream. More...
std::vector< Gaudi::Algorithm * > | m_acceptAlgs
| Vector of Algorithms that this stream accepts. More...
std::vector< Gaudi::Algorithm * > | m_requireAlgs
| Vector of Algorithms that this stream requires. More...
std::vector< Gaudi::Algorithm * > | m_vetoAlgs
| Vector of Algorithms that this stream is vetoed by. More...
Protected Attributes inherited from Gaudi::Algorithm
std::unique_ptr< IDataHandleVisitor > | m_updateDataHandles
| Hook for for derived classes to provide a custom visitor for data handles. More...
Protected Attributes inherited from DataHandleHolderBase< CounterHolder< PropertyHolder< CommonMessaging< implements< IAlgorithm, IDataHandleHolder, IProperty, IStateful > > > > >
DataObjIDColl | m_inputDataObjs
DataObjIDColl | m_outputDataObjs

## Detailed Description

Extension of OutputStream to copy the content of the main input file.

On top of the standard behavior of OutputStream, this class takes also all the entries that come from the same file as the root entry in the data service.

Author
  : M. Frank
  : P. Koppenburg
  : M. Clemencic

Definition at line 19 of file InputCopyStream.h.

## Constructor & Destructor Documentation

## ◆ InputCopyStream()

InputCopyStream::InputCopyStream | ( | const std::string & | name,
|  | ISvcLocator * | pSvcLocator
| ) |  |

Standard algorithm Constructor.

Definition at line 16 of file InputCopyStream.cpp.

17 : OutputStream( name, pSvcLocator ) {
18 m_doPreLoad = false;
19 m_doPreLoadOpt = false;
20 }
OutputStream::m_doPreLoad
Gaudi::Property< bool > m_doPreLoad
Definition: OutputStream.h:49
OutputStream
A small to stream Data I/O.
Definition: OutputStream.h:28
OutputStream::m_doPreLoadOpt
Gaudi::Property< bool > m_doPreLoadOpt
Definition: OutputStream.h:51
Gaudi::Algorithm::name
const std::string & name() const override
The identifying name of the algorithm object.
Definition: Algorithm.cpp:645

## Member Function Documentation

## ◆ collectObjects()

StatusCode InputCopyStream::collectObjects | ( |  | ) |
| override virtual

Collect all objects to be written to the output stream.

Reimplemented from OutputStream.

Definition at line 39 of file InputCopyStream.cpp.

39 {
40 // Get the objects in the same file as the root node
41 try {
42 // Get all the leaves on the input stream
43 const IDataStoreLeaves::LeavesList& leaves = m_leavesTool->leaves();
44
45 // Do we need to veto anything ?
46 if ( UNLIKELY( !m_tesVetoList.empty() ) ) {
47 // Veto out locations
48 IDataStoreLeaves::LeavesList filteredLeaves;
49 filteredLeaves.reserve( leaves.size() );
50 std::copy_if( leaves.begin(), leaves.end(), std::back_inserter( filteredLeaves ),
51 [&]( IDataStoreLeaves::LeavesList::const_reference i ) {
52 return i && i->registry() &&
53 std::find( m_tesVetoList.begin(), m_tesVetoList.end(), i->registry()->identifier() ) ==
54 m_tesVetoList.end();
55 } );
56 // save the veto'ed list
57 m_objects.assign( filteredLeaves.begin(), filteredLeaves.end() );
58
59 } else {
60 // no veto'ing, so save everything
61 m_objects.assign( leaves.begin(), leaves.end() );
62 }
63 } catch ( const GaudiException& e ) {
64 error() << e.message() << endmsg;
65 return StatusCode::FAILURE;
66 }
67
68 // Collect the other objects from the transient store (mandatory and optional)
69 return OutputStream::collectObjects();
70 }
UNLIKELY
#define UNLIKELY(x)
Definition: Kernel.h:96
std::copy_if
T copy_if(T... args)
GaudiException
Define general base for Gaudi exception.
Definition: GaudiException.h:21
OutputStream::m_objects
IDataSelector m_objects
Collection of objects being selected.
Definition: OutputStream.h:105
GaudiException::message
virtual const std::string & message() const
error message to be printed
Definition: GaudiException.h:58
std::vector::end
T end(T... args)
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:98
InputCopyStream::m_leavesTool
IDataStoreLeaves * m_leavesTool
Pointer to the (public) tool used to retrieve the objects in a file.
Definition: InputCopyStream.h:36
InputCopyStream::m_tesVetoList
Gaudi::Property< std::vector< std::string > > m_tesVetoList
Definition: InputCopyStream.h:38
std::find
T find(T... args)
std::vector::size
T size(T... args)
std::vector::assign
T assign(T... args)
std::vector< DataObject * >
IDataStoreLeaves::leaves
virtual const LeavesList & leaves() const =0
Return the list of leaves.
std::vector::begin
T begin(T... args)
std::back_inserter
T back_inserter(T... args)
StatusCode::FAILURE
constexpr static const auto FAILURE
Definition: StatusCode.h:86
OutputStream::collectObjects
virtual StatusCode collectObjects()
Collect all objects to be written to the output stream.
Definition: OutputStream.cpp:226
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
std::vector::reserve
T reserve(T... args)

## ◆ finalize()

StatusCode InputCopyStream::finalize | ( |  | ) |
| override

Finalize the instance.

Definition at line 32 of file InputCopyStream.cpp.

32 {
33 toolSvc()->releaseTool( m_leavesTool ).ignore();
34 m_leavesTool = nullptr;
35 return OutputStream::finalize();
36 }
OutputStream::finalize
StatusCode finalize() override
Terminate OutputStream.
Definition: OutputStream.cpp:123
Gaudi::Algorithm::toolSvc
SmartIF< IToolSvc > & toolSvc() const
The standard ToolSvc service, Return a pointer to the service if present.
Definition: Algorithm.cpp:683
InputCopyStream::m_leavesTool
IDataStoreLeaves * m_leavesTool
Pointer to the (public) tool used to retrieve the objects in a file.
Definition: InputCopyStream.h:36
StatusCode::ignore
const StatusCode & ignore() const
Ignore/check StatusCode.
Definition: StatusCode.h:153
IToolSvc::releaseTool
virtual StatusCode releaseTool(IAlgTool *tool)=0
Release the tool.

## ◆ hasInput()

bool InputCopyStream::hasInput | ( |  | ) | const
| inline override protected virtual

Overridden from the base class (InputCopyStream has always input).

Reimplemented from OutputStream.

Definition at line 42 of file InputCopyStream.h.

42 { return true; }

## ◆ initialize()

StatusCode InputCopyStream::initialize | ( |  | ) |
| override

Initialize the instance.

Definition at line 23 of file InputCopyStream.cpp.

23 {
24 StatusCode sc = OutputStream::initialize();
25 if ( sc.isFailure() ) return sc;
26
27 sc = toolSvc()->retrieveTool( "DataSvcFileEntriesTool", "InputCopyStreamTool", m_leavesTool );
28 return sc;
29 }
Gaudi::Algorithm::toolSvc
SmartIF< IToolSvc > & toolSvc() const
The standard ToolSvc service, Return a pointer to the service if present.
Definition: Algorithm.cpp:683
IToolSvc::retrieveTool
StatusCode retrieveTool(const std::string &type, T *&tool, const IInterface *parent=nullptr, bool createIf=true)
Retrieve specified tool sub-type with tool dependent part of the name automatically assigned.
Definition: IToolSvc.h:138
OutputStream::initialize
StatusCode initialize() override
Initialize OutputStream.
Definition: OutputStream.cpp:36
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
InputCopyStream::m_leavesTool
IDataStoreLeaves * m_leavesTool
Pointer to the (public) tool used to retrieve the objects in a file.
Definition: InputCopyStream.h:36
StatusCode::isFailure
bool isFailure() const
Definition: StatusCode.h:130

## Member Data Documentation

## ◆ m_leavesTool

IDataStoreLeaves* InputCopyStream::m_leavesTool = nullptr
| private

Pointer to the (public) tool used to retrieve the objects in a file.

Definition at line 36 of file InputCopyStream.h.

## ◆ m_tesVetoList

Gaudi::Property<std::vector<std::string> > InputCopyStream::m_tesVetoList {this, "TESVetoList", {}, "names of TES locations to Veto"}
| private

Definition at line 38 of file InputCopyStream.h.

The documentation for this class was generated from the following files:

- GaudiCommonSvc/src/PersistencySvc/InputCopyStream.h
- GaudiCommonSvc/src/PersistencySvc/InputCopyStream.cpp